Loading...
Searching...
No Matches
Opm::Component< ScalarT, Implementation > Class Template Reference

Abstract base class of a pure chemical species. More...

`#include <Component.hpp>`

Inheritance diagram for Opm::Component< ScalarT, Implementation >:

## Public Types

typedef ScalarT | Scalar

## Static Public Member Functions

static void | init (Scalar, Scalar, unsigned, Scalar, Scalar, unsigned)
| A default routine for initialization, not needed for components and must not be called.
static bool | gasIsCompressible ()
| Returns true iff the gas phase is assumed to be compressible.
static bool | gasIsIdeal ()
| Returns true iff the gas phase is assumed to be ideal.
static bool | liquidIsCompressible ()
| Returns true iff the liquid phase is assumed to be compressible.
static std::string_view | name ()
| A human readable name for the component.
static Scalar | molarMass ()
| The molar mass in of the component.
static Scalar | criticalTemperature ()
| Returns the critical temperature in of the component.
static Scalar | criticalPressure ()
| Returns the critical pressure in of the component.
static Scalar | acentricFactor ()
| Returns the acentric factor of the component.
static Scalar | criticalVolume ()
| Returns the critical volume in of the component.
static Scalar | tripleTemperature ()
| Returns the temperature in at the component's triple point.
static Scalar | triplePressure ()
| Returns the pressure in at the component's triple point.
template<class Evaluation>
static Evaluation | vaporPressure (const Evaluation &)
| The vapor pressure in of the component at a given temperature in .
template<class Evaluation>
static Evaluation | gasDensity (const Evaluation &, const Evaluation &)
| The density in of the component at a given pressure in and temperature in .
template<class Evaluation>
static Evaluation | liquidDensity (const Evaluation &, const Evaluation &)
| The density of the liquid component at a given pressure in and temperature in .
template<class Evaluation>
static Evaluation | gasEnthalpy (const Evaluation &, const Evaluation &)
| Specific enthalpy of the pure component in gas.
template<class Evaluation>
static Evaluation | liquidEnthalpy (const Evaluation &, const Evaluation &)
| Specific enthalpy of the pure component in liquid.
template<class Evaluation>
static Evaluation | gasInternalEnergy (const Evaluation &, const Evaluation &)
| Specific internal energy of the pure component in gas.
template<class Evaluation>
static Evaluation | liquidInternalEnergy (const Evaluation &, const Evaluation &)
| Specific internal energy of pure the pure component in liquid.
template<class Evaluation>
static Evaluation | gasViscosity (const Evaluation &, const Evaluation &)
| The dynamic viscosity of the pure component at a given pressure in and temperature in .
template<class Evaluation>
static Evaluation | liquidViscosity (const Evaluation &, const Evaluation &)
| The dynamic liquid viscosity of the pure component.
template<class Evaluation>
static Evaluation | gasThermalConductivity (const Evaluation &, const Evaluation &)
| Thermal conductivity of the component [W/(m^2 K/m)] as a gas.
template<class Evaluation>
static Evaluation | liquidThermalConductivity (const Evaluation &, const Evaluation &)
| Thermal conductivity of the component [W/(m^2 K/m)] as a liquid.
template<class Evaluation>
static Evaluation | gasHeatCapacity (const Evaluation &, const Evaluation &)
| Specific isobaric heat capacity of the component [J/kg] as a gas.
template<class Evaluation>
static Evaluation | liquidHeatCapacity (const Evaluation &, const Evaluation &)
| Specific isobaric heat capacity of the component [J/kg] as a liquid.

## Static Public Attributes

static constexpr bool | isTabulated = false

## Detailed Description

template<class ScalarT, class Implementation>
class Opm::Component< ScalarT, Implementation >

Abstract base class of a pure chemical species.

Template Parameters

  ScalarT | The type used for scalar values
  Implementation | Necessary for static polymorphism

## Member Function Documentation

## gasDensity()

template<class ScalarT, class Implementation>
template<class Evaluation>

Evaluation Opm::Component< ScalarT, Implementation >::gasDensity | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

The density in of the component at a given pressure in and temperature in .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## gasEnthalpy()

template<class ScalarT, class Implementation>
template<class Evaluation>

Evaluation Opm::Component< ScalarT, Implementation >::gasEnthalpy | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

Specific enthalpy of the pure component in gas.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## gasInternalEnergy()

template<class ScalarT, class Implementation>
template<class Evaluation>

Evaluation Opm::Component< ScalarT, Implementation >::gasInternalEnergy | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

Specific internal energy of the pure component in gas.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## gasViscosity()

template<class ScalarT, class Implementation>
template<class Evaluation>

Evaluation Opm::Component< ScalarT, Implementation >::gasViscosity | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

The dynamic viscosity of the pure component at a given pressure in and temperature in .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## init()

template<class ScalarT, class Implementation>

void Opm::Component< ScalarT, Implementation >::init | ( | Scalar | ,
|  | Scalar | ,
|  | unsigned | ,
|  | Scalar | ,
|  | Scalar | ,
|  | unsigned | )

inline static

A default routine for initialization, not needed for components and must not be called.

Parameters

  tempMin | The minimum of the temperature range in
  tempMax | The maximum of the temperature range in
  nTemp | The number of entries/steps within the temperature range
  pressMin | The minimum of the pressure range in
  pressMax | The maximum of the pressure range in
  nPress | The number of entries/steps within the pressure range

This function throws a warning when called: "No init routine defined - make sure that this is not necessary!"

## liquidDensity()

template<class ScalarT, class Implementation>
template<class Evaluation>

Evaluation Opm::Component< ScalarT, Implementation >::liquidDensity | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

The density of the liquid component at a given pressure in and temperature in .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## liquidEnthalpy()

template<class ScalarT, class Implementation>
template<class Evaluation>

Evaluation Opm::Component< ScalarT, Implementation >::liquidEnthalpy | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

Specific enthalpy of the pure component in liquid.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## liquidInternalEnergy()

template<class ScalarT, class Implementation>
template<class Evaluation>

Evaluation Opm::Component< ScalarT, Implementation >::liquidInternalEnergy | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

Specific internal energy of pure the pure component in liquid.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## liquidViscosity()

template<class ScalarT, class Implementation>
template<class Evaluation>

Evaluation Opm::Component< ScalarT, Implementation >::liquidViscosity | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

The dynamic liquid viscosity of the pure component.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## vaporPressure()

template<class ScalarT, class Implementation>
template<class Evaluation>

Evaluation Opm::Component< ScalarT, Implementation >::vaporPressure | ( | const Evaluation & |  | ) |

inline static

The vapor pressure in of the component at a given temperature in .

Parameters

  temperature | temperature of the component in

The documentation for this class was generated from the following file:

- opm/material/components/Component.hpp